/**
 * @file mocap_relay_node.cpp
 * @brief Node to simulate mocap generated by AirSim
 * @author Parker Lusk <plusk@mit.edu>
 * @date 21 March 2020
 */

#include "snap_airsim/mocap_relay_node.h"

namespace acl {
namespace snap_airsim {

MocapRelay::MocapRelay(const ros::NodeHandle& nh, const ros::NodeHandle& nhp)
: nh_(nh), nhp_(nhp)
{
  // Check namespace to find name of vehicle
  name_ = ros::this_node::getNamespace();
  const size_t n = name_.find_first_not_of('/');
  name_.erase(0, n); // remove leading slashes
  if (name_.empty()) {
    ROS_ERROR("Error :: You should be using a launch file to specify the "
              "node namespace!\n");
    ros::shutdown();
    return;
  }

  //
  // Simulated mocap initialization
  //

  // what frame should mocap be published w.r.t?
  nhp_.param<std::string>("mocap_tf_parent_frame", mocap_parent_frame_, "world");
  nhp_.param<bool>("mocap_tf_broadcast", mocap_tf_broadcast_, true);

  sub_odom_ = nh_.subscribe("odom_local_ned", 1, &MocapRelay::odomCb, this);
  pub_pose_ = nh_.advertise<geometry_msgs::PoseStamped>("world", 1);
  pub_twist_ = nh_.advertise<geometry_msgs::TwistStamped>("mocap/twist", 1);

  //
  // Visualization
  //

  nhp_.param<bool>("viz_mesh", viz_mesh_, true);
  nhp_.param<std::string>("mesh_uri", mesh_uri_, "package://snap_sim/meshes/quadrotor.dae");
  nhp_.param<double>("mesh_scale", mesh_scale_, 0.75);
  if (viz_mesh_) pub_vizmesh_ = nh_.advertise<visualization_msgs::Marker>("viz_mesh", 1);

}

// ----------------------------------------------------------------------------
// Private Methods
// ----------------------------------------------------------------------------

geometry_msgs::Pose MocapRelay::toENUPose(const geometry_msgs::Pose& msg)
{
  // frd-body w.r.t ned-world
  tf2::Transform T_WnedBfrd;
  tf2::fromMsg(msg, T_WnedBfrd);

  // flu-body w.r.t frd-body
  tf2::Transform T_BfrdBflu;
  T_BfrdBflu.setIdentity();
  tf2::Quaternion quat0; quat0.setRPY(M_PI, 0, 0);
  T_BfrdBflu.setRotation(quat0);

  // ned-world w.r.t enu-world
  tf2::Transform T_WenuWned;
  T_WenuWned.setIdentity();
  tf2::Quaternion quat1; quat1.setRPY(M_PI, 0, M_PI/2);
  T_WenuWned.setRotation(quat1);  

  // flu-body w.r.t enu-world
  tf2::Transform T_WB = T_WenuWned * T_WnedBfrd * T_BfrdBflu;

  geometry_msgs::Pose pose;
  tf2::toMsg(T_WB, pose);
  return pose;
}

// ----------------------------------------------------------------------------

void MocapRelay::odomCb(const nav_msgs::OdometryConstPtr& msg)
{
  geometry_msgs::PoseStamped msgpose;
  msgpose.header.stamp = msg->header.stamp;
  msgpose.header.frame_id = mocap_parent_frame_;
  msgpose.pose = toENUPose(msg->pose.pose);
  pub_pose_.publish(msgpose);

  geometry_msgs::TwistStamped msgtwist;
  msgtwist.header.stamp = msg->header.stamp;
  msgtwist.header.frame_id = mocap_parent_frame_; // expressed in world frame
  msgtwist.twist = msg->twist.twist; // TODO: this is in the wrong frame
  pub_twist_.publish(msgtwist);

  if (mocap_tf_broadcast_) {
    geometry_msgs::TransformStamped msgtf;
    msgtf.header = msgpose.header;
    msgtf.transform.rotation = msgpose.pose.orientation;
    msgtf.transform.translation.x = msgpose.pose.position.x;
    msgtf.transform.translation.y = msgpose.pose.position.y;
    msgtf.transform.translation.z = msgpose.pose.position.z;
    msgtf.child_frame_id = name_;
    br_.sendTransform(msgtf);
  }

  //
  // Visualization
  //

  if (viz_mesh_) {
    visualization_msgs::Marker m;
    m.action = visualization_msgs::Marker::ADD;
    m.ns = "mesh";
    m.id = 1;
    m.type = visualization_msgs::Marker::MESH_RESOURCE;
    m.mesh_resource = mesh_uri_;
    m.mesh_use_embedded_materials = true;
    m.color.a = 0.0;
    m.color.r = 0.0;
    m.color.g = 0.0;
    m.color.b = 0.0;
    m.header = msgpose.header;
    m.pose = msgpose.pose;
    m.scale.x = mesh_scale_;
    m.scale.y = mesh_scale_;
    m.scale.z = mesh_scale_;
    m.lifetime = ros::Duration(1.0);

    pub_vizmesh_.publish(m);
  }
}

} // ns snap_airsim
} // ns acl

// ============================================================================
// ============================================================================

int main(int argc, char *argv[])
{
  ros::init(argc, argv, "mocap_relay");
  ros::NodeHandle nhtopics("");
  ros::NodeHandle nhparams("~");
  acl::snap_airsim::MocapRelay obj(nhtopics, nhparams);
  ros::spin();
  return 0;
}
